<?php

class PageController
{
    /**
     * @var string
     */
    protected $hook;

    /**
     * @var array
     */
    protected $variables = array();

    /**
     * Get the callable.
     *
     * @return string|callable
     */
    public function __construct()
    {
        global $user;
        $this->user = $user;
    }

    /**
     * Set the variables.
     *
     * @return array
     */
    public function setVariable($name, $value)
    {
        $this->variables[$name] = $value;
    }

    /**
     * Set the hook.
     *
     * @return string
     */
    public function setTemplate($value)
    {
        $this->hook = $value;
    }

    /**
     *  Render a page.
     *
     * @return string
     */
    public function render()
    {
        if (drupal_is_front_page()) {
            $this->setTemplate('hunter__front');
        }
        $this->setVariable('user', $this->user);

        if (empty($this->hook)) {
            $suggestions = theme_get_suggestions(arg(), 'hunter');
            $suggestions = array_reverse($suggestions);
            $this->hook = array_shift($suggestions);
        }

        return theme($this->hook, array('variables' => $this->variables));
    }
}
